/**************************************************																																																																					/****************************************
 *  $B%j%A%&%`%$%*%s=<EECSMQ=<EE4o(B
 *  PIC16F1783$B$r;HMQ(B
 * $B!!=<EEEE05B,Dj!"=<EEEEN.B,Dj!J(BOPAMP$B;HMQ!K(B
 * $B!!J|EEDjEEN.(B(OPAMP$B;HMQ!K!"J|EEEE05B,Dj!!(B
***************************************************/
#include  <xc.h>
#include  "lcd_lib3.h"
#include  "i2c_lib3.h"

/***** $B%3%s%U%#%.%e%l!<%7%g%s@_Dj(B *********/
// CONFIG1
#pragma config FOSC = INTOSC    // Oscillator Selection (INTOSC oscillator: I/O function on CLKIN pin)
#pragma config WDTE = OFF       // Watchdog Timer Enable (WDT disabled)
#pragma config PWRTE = ON       // Power-up Timer Enable (PWRT enabled)
#pragma config MCLRE = ON       // MCLR Pin Function Select (MCLR/VPP pin function is MCLR)
#pragma config CP = OFF         // Flash Program Memory Code Protection (Program memory code protection is disabled)
#pragma config CPD = OFF        // Data Memory Code Protection (Data memory code protection is disabled)
#pragma config BOREN = ON       // Brown-out Reset Enable (Brown-out Reset enabled)
#pragma config CLKOUTEN = OFF   // Clock Out Enable (CLKOUT function is disabled. I/O or oscillator function on the CLKOUT pin)
#pragma config IESO = OFF       // Internal/External Switchover (Internal/External Switchover mode is disabled)
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable (Fail-Safe Clock Monitor is disabled)

// CONFIG2
#pragma config WRT = OFF        // Flash Memory Self-Write Protection (Write protection off)
#pragma config VCAPEN = ON      // Voltage Regulator Capacitor Enable bit (Vcap functionality is enabled on RA6 (Vddcore is connected to the pad))
#pragma config PLLEN = ON       // PLL Enable (4x PLL enabled)
#pragma config STVREN = OFF     // Stack Overflow/Underflow Reset Enable (Stack Overflow or Underflow will not cause a Reset)
#pragma config BORV = HI        // Brown-out Reset Voltage Selection (Brown-out Reset Voltage (Vbor), high trip point selected.)
#pragma config LPBOR = OFF      // Low Power Brown-Out Reset Enable Bit (Low power brown-out is disabled)
#pragma config LVP = OFF        // Low-Voltage Programming Enable (High-voltage on MCLR/VPP must be used for programming)

/**** $BDj?t!"JQ?t$NDj5A(B *****/
float cVolt, dVolt, cCurrent, dCurrent;
int cVtemp, dVtemp, cCtemp, dCtemp, Temp, Interval;;
char Index, OnLine, Flag, EndFlag;
#define Max_Size 32
unsigned char RcvFlag;
unsigned char RcvBuf[32], SndBuf[32], Buffer[32];
/* Bluetooth$B@_DjMQ%3%^%s%I%G!<%?(B */
const unsigned char msg1[] = "$$$";               // $B%3%^%s%I%b!<%I;XDj(B
const unsigned char msg2[] = "SF,1\r";            // $B9)>l=P2Y%j%;%C%H(B
const unsigned char msg3[] = "SN,Cahrger Monitor\r";// $BL>>N@_Dj(B
const unsigned char msg4[] = "SA,4\r";            // $BG'>Z%b!<%I(B
const unsigned char msg5[] = "R,1\r";             // $B:F5/F0(B
/*** $B1U>=I=<(%a%C%;!<%8(B *****/
const char StMsg[] = "Start!";
char CrgMsg[] = "Chg x.xxV  xxxmA";
char DisMsg[] = "Dis x.xxV  xxxmA";
const char BlnkMsg[] = "                ";
const char OnMsg[]   = "On Line Data Send";
/** $B%W%m%H%?%$%T%s%0(B **/
int ADConv(unsigned char ch);
void ftostring(int seisu, int shousu, float data, unsigned char *buffer);
void Init(void);
void SendCmd(const unsigned char *cmd);
void SendStr(unsigned char * str);
void Send(unsigned char txchar);
void Process(void);

/*********** $B%a%$%s4X?t(B **************/
void main(void)
{
    /** Clock Setting **/
    OSCCONbits.IRCF = 14;                       // 8MHz
    OSCCONbits.SCS = 0;                         // Configuration
    /* I/O$B=i4|@_Dj(B */
    TRISA = 0xFF;                               // $B$9$Y$FF~NO(B
    TRISB = 0xCF;                               // RB4,5$B$N$_=PNO(B
    TRISC = 0x9B;                               // RC2,5,6$B$N$_=PNO(B
    ANSELA = 0x3F;                              // RA6,7$B$N$_%G%8%?%k(B
    ANSELB = 0x0F;                              // RB0-3$B%"%J%m%0(B
    /* $B%9%$%C%AMQ%W%k%"%C%W!J%G%U%)%k%H$,$"$j$H$J$C$F$$$k!K(B */
    WPUA = 0;                                   // $B%W%k%"%C%W$J$7(B
    WPUB = 0;                                   // $B%W%k%"%C%W$J$7(B
    WPUC = 0x03;                                // RC0,1$B%W%k%"%C%W(B
    OPTION_REGbits.nWPUEN = 0;                  // $B%W%k%"%C%WM-8z2=(B
    /* $BFbB"%b%8%e!<%k=i4|2=4X?t(B */
    Init();                                     // $B=i4|2=<B9T(B
    /** Timer1$B=i4|@_Dj(B  8MHz/8=1MHz **/
    T1CON = 0x30;                               // Fcy, 1/8
    TMR1H = 0x3C;
    TMR1L = 0xAF;                               // 50msec
    T1CONbits.TMR1ON = 1;                       // Timer1 Start
    /* BT$B%b%8%e!<%k=i4|2=(B */
    LATCbits.LATC5 = 0;                         // BT$B%b%8%e!<%k%j%;%C%H(B
    Delayms(100);                               // $B%j%;%C%H;~4V(B
    LATCbits.LATC5 = 1;                         // $B%j%;%C%H2r=|(B
    Delayms(500);                               // $B=i4|2=40N;BT$A(B
    /* USART$B$N=i4|@_Dj(B */
    TXSTA = 0x20;                               // TXSTA,$BAw?.%b!<%I@_Dj(B BRGH=1
    RCSTA = 0x90;                               // RCSTA,$B<u?.%b!<%I@_Dj(B
    BAUDCON=0x08;                               // BAUDCON$B!!(B16bit
    SPBRG = 16;                                 // SPBRG,$BDL?.B.EY@_Dj(B(115kbps)
    /*Bluetooth$B%b%8%e!<%k$N@_Dj(B */
    if(PORTCbits.RC1 == 0){                     // SW$B$,2!$5$l$F$$$k>l9g(B
        SendCmd(msg1);                          // $$$$B%3%^%s%I%b!<%I$X(B
        SendCmd(msg2);                          // $B9)>l=P2Y;~$X%j%;%C%H(B
        SendCmd(msg3);                          // $BL>>N@_Dj(B
        SendCmd(msg4);                          // $BG'>Z%b!<%I;XDj(B
        SendCmd(msg5);                          // $B%j%V!<%H(B
    }
    /* USART $B:F@_Dj(B*/
    TXSTA = 0x20;                               // TXSTA,$BAw?.%b!<%I@_Dj(B BRGH=0
    RCSTA = 0x90;                               // RCSTA,$B<u?.%b!<%I@_Dj(B
    /** $B1U>=I=<(4oMQ(B I2C$B=i4|2=(B **/
    SSPADD = 0x4F;                              // 100kHz@8MHz
    SSPCON1 = 0x38;                             // I2C$B%$%M!<%V%k(B
    SSPSTAT = 0;                                // $B>uBV%/%j%"(B
    /* $B3+;O%a%C%;!<%8I=<((B */
    lcd_init();                                 // $B=i4|2=(B
    lcd_clear();                                // $BA4>C5n(B
    lcd_str(StMsg);                             // $B3+;O%a%C%;!<%8(B
    lcd_icon(0, 0);                             // $B%"%$%3%s>C5n(B
    lcd_icon(2, 0);
    Delayms(500);				// 0.5$BIC4VI=<((B
    /* $BJQ?t=i4|2=(B */
    Index = 0;
    RcvFlag = 0;
    OnLine = 0;
    Interval = 0;
    EndFlag = 0;
    /* UART$B<u?.3d$j9~$_5v2D(B */
    PIR1bits.TMR1IF = 0;                        // $B%?%$%^(B1$B3d$j9~$_%U%i%0%/%j%"(B
    PIE1bits.TMR1IE = 1;                        // $B%?%$%^(B1$B3d$j9~$_5v2D(B
    PIR1bits.RCIF = 0;                          // $B3d$j9~$_%U%i%0%/%j%"(B
    PIE1bits.RCIE = 1;                          // USART$B<u?.3d$j9~$_5v2D(B
    INTCONbits.PEIE = 1;                        // $B<~JU5v2D(B
    INTCONbits.GIE = 1;                         // $B%0%m!<%P%k5v2D(B

    /********* $B%a%$%s%k!<%W(B *************/
    while(1){
       if(RcvFlag){                             // $B<u?.$"$j$N>l9g(B
            RcvFlag = 0;                        // $B<u?.%U%i%0%/%j%"(B
            /* $B<u?.%3%^%s%I=hM}(B */
            if((Buffer[0] == 'S')){             // $B%X%C%@3NG'(B
                Process();                      // $B%3%^%s%I=hM}<B9T(B
             }
        }
        /************** $B%G!<%?7WB,I=<(<B9T(B *****************/
        /** $B=<EEEE05F~NO(B $BJd@5CM!!(B4.096V * 6.1/5.1=4.899 **/
        cVtemp = ADConv(0);                     // AN0$B7WB,(B
        cVolt = ((float)cVtemp * 4.899)/4096;   // $B<B5!Jd@54^$`(B
        ftostring(1, 2, cVolt, CrgMsg+4);       // $BI=<(%P%C%U%!$K3JG<(B
        /** $BEEN.F~NO(B  $BJd@5CM!!(B4096mA/0.33/8.1=1532 **/
        cCtemp = ADConv(10);                    // AN10$B7WB,(B
        cCurrent = ((float)cCtemp * 1532.0) / 4096;
        ftostring(3, 0, cCurrent, CrgMsg+11);   // $BI=<(%P%C%U%!$K3JG<(B
        /** $BI=<(=PNO(B ***/
        lcd_cmd(0x80);                          // 1$B9TL\;XDj(B
        lcd_str(CrgMsg);                        // $BB,DjCMI=<((B
        /**** $BJ|EEEE05F~NO(B ****/
        dVtemp = ADConv(3);                     // AN3
        dVolt = ((float)dVtemp * 4.899)/4096;   // $B<B5!Jd@54^$`(B
        ftostring(1, 2, dVolt, DisMsg+4);       // $BI=<(%P%C%U%!$K3JG<(B
        /****$B!!J|EEEEN.B,Dj(B  ***/
        dCtemp = ADConv(4);                     // AN4
        dCurrent = ((float)dCtemp * 4096.0)/4096;// $B<B5!Jd@54^$`(B
        ftostring(3, 0, dCurrent, DisMsg+11);   // $BI=<(%P%C%U%!$K3JG<(B
        /** $BI=<(=PNO(B ***/        
        lcd_cmd(0xC0);                          // 2$B9TL\;XDj(B
        lcd_str(DisMsg);                        // $BB,DjCMI=<((B
        /****** $BJ|EE=*N;%A%'%C%/(B **************/
        if((dVolt > 3.0) && (EndFlag == 0)){    // $BEE05(B3.0V$B0J>e$GJ|EEL$=*N;$N>l9g(B
            /****** $B2DJQDq93$K$h$kJ|EEEEN.$N@_Dj(B **/
            Temp = ADConv(12);                  // POT$B$NEE05F~NO(B
            Temp /= 32;                         // 12$B%S%C%H"*(B7$B%S%C%H(B
            if(Temp > 130)                      // $B:GBg(B500mA$B$G@)8B(B
                Temp = 130;
            DACCON1 = Temp;                     // D/A$B=PNOEE05@_Dj(B
        }
        else{                                   // 3.0V$B0J2<$N>l9gJ|EE=*N;(B
            DACCON1 = 1;                        // $BEEN.:GDcCMJ|EE=*N;(B
            EndFlag = 1;                        // $BJ|EE=*N;%U%i%0%;%C%H(B
        }
        if((OnLine == 1) && (Interval >= 300)){ // 15$BIC<~4|(B
            Interval = 0;                       // $BAw?.4V3V%j%;%C%H(B
            /***** $B%*%s%i%$%s$N>l9g!!%G!<%?Aw?.(B ************/
            SndBuf[0] = 'M';                    // $B%X%C%@%;%C%H(B
            SndBuf[1] = 'A';                    // $B%X%C%@%;%C%H(B
            SndBuf[2] = cVtemp / 128;           // $B=<EEAw?.%G!<%?%;%C%H(B
            SndBuf[3] = cVtemp % 128;
            SndBuf[4] = cCtemp / 128;
            SndBuf[5] = cCtemp % 128;
            SndBuf[6] = dVtemp / 128;           // $BJ|EEAw?.%G!<%?%;%C%H(B
            SndBuf[7] = dVtemp % 128;
            SndBuf[8] = dCtemp / 128;
            SndBuf[9] = dCtemp % 128;
            SndBuf[10] = 'E';                   // $B=*N;%^!<%/%;%C%H(B
            SendStr(SndBuf);                    // 32$B%P%$%H8GDjD9Aw?.<B9T(B
            /** $BL\0u(BLCD$B%"%$%3%sI=<((B ***/
            if(Flag){
                lcd_icon(2, 1);                 // $B%"%$%3%sH?E>(B
                Flag = 0;
            }
            else{
                lcd_icon(2, 0);                 // $B%"%$%3%sH?E>(B
                Flag = 1;
            }
        }
        /* $BJ|EE%^%K%e%"%k3+;O(B **/
        if(PORTCbits.RC0 == 0)                  // S2$B%*%s$N>l9g(B
            EndFlag = 0;                        // $BJ|EE=*N;%U%i%0%/%j%"(B
        Delayms(1000);                          // $B7WB,4V3VCY1d(B
    }
}
/**********************************************************
* $B<u?.%3%^%s%I=hM}<B9T4X?t!!!!%X%C%@$N2r@O(B
***********************************************************/
void Process(void){
    /****** $B%3%^%s%I2r@O$H=hM}(B ***********/
    switch(Buffer[1]){                          // $B%3%^%s%I<hF@(B
        /* $B@\B33NG'MW5a$N>l9g(B */
        case 'O':
            SndBuf[0] = 'M';                    // $B%G!<%?Aw?.3+;OMW5a(B
            SndBuf[1] = 'O';                    // OK$B%a%C%;!<%8JVAw(B
            SndBuf[2] = 'K';
            SndBuf[3] = 'E';
            SendStr(SndBuf);                    // 32$B%P%$%H8GDjD9Aw?.(B
            lcd_icon(0, 1);                     // $B%"%s%F%J%"%$%3%sI=<((B
            Flag = 1;
            OnLine = 1;
            EndFlag = 0;
            break;
        case 'N':                               // $BAw?.=*N;(B
            OnLine = 0;                         // $B%*%U%i%$%s$K(B
            lcd_icon(0, 0);                     // $B%"%$%3%s>C5n(B
            break;
        default :
            break;
    }
}

/***************************************
*  A/D$BJQ49F~NO4X?t!!(B100$B2s7WB,$7J?6Q$r$H$k(B
****************************************/
int ADConv(unsigned char ch){
    int i, j;
    long value;

    value = 0;                                  // $B@Q;;%/%j%"(B
    for(j=0; j<100; j++){                       // 100$B2s7+$jJV$7(B
        ADCON0bits.CHS = ch;                    // $B%A%c%M%kA*Br(B
        for(i=0; i<100; i++);                   // $B%"%/%$%8%7%g%s%?%$%`BT$A(B
        ADCON0bits.GO = 1;                      // $BJQ493+;O(B
        while(ADCON0bits.GO);                   // $BJQ49=*N;BT$A(B
        if(ADRESH > 0x80){                       // $BIi$NCM$N>l9g(B
            ADRESH = 0;                         // 0$B$K@)8B(B
            ADRESL = 0;
        }
        value += ((ADRESH & 0x0F)*256 + ADRESL);// $B@Q;;(B
    }
    value /= 100;                               // $BJ?6Q$r5a$a$k(B
    return((int)value);                         // $BJQ497k2L$rJV$9(B
}
/***********************************
* Float$B$+$iJ8;zNs$XJQ49(B
* $B9g7WM-8z7e$O(B8$B7e0J2<$H$9$k$3$H(B
***********************************/
void ftostring(int seisu, int shousu, float data, unsigned char *buffer)
{
	int i;
	long dumy;

	if(shousu != 0)				//$B>.?tIt7e$"$j$+(B
		buffer += seisu+shousu+1;	//$BA4BN7e?t!\>.?tE@(B
	else					//$B>.?tIt7e$J$7$N$H$-(B
		buffer += seisu + shousu;	//$BA4BN7e?t$N$_(B
	buffer--;				//$BG[Ns%]%$%s%?(B-1
	for(i=0; i<shousu; i++)			//$B>.?tIt$r@0?t$KJQ49(B
		data = data * 10;		//$B#1#0G\(B
	/// dumy$B$,%*!<%P!<%U%m!<$9$k$HJQ49IT2D(B($B#87e$,8B3&(B)
	dumy = (long) (data + 0.5);		//$B;M<N8^F~$7$F@0?t$KJQ49(B
	for(i=shousu; i>0; i--)	{		//$B>.?t7e?tJ,7+$jJV$7(B
		*buffer =(dumy % 10)+'0';	//$B?tCM$rJ8;z$KJQ493JG<(B
		buffer--;			//$B3JG<>l=j2<0L$+$i>e0L$X(B
		dumy /= 10;			//$B<!$N7e$X(B
	}
	if(shousu != 0) {			//$B>.?t7e(B0$B$J$i>.?tE@$J$7(B
		*buffer = '.';			//$B>.?tE@$r3JG<(B
		buffer--;			//$B%]%$%s%?(B-1
	}
	for(i=seisu; i>0; i--) {		//$B@0?t7eJ,7+$jJV$7(B
		*buffer = (dumy % 10)+'0';	//$B?tCM$rJ8;z$KJQ493JG<(B
		buffer--;			//$B%]%$%s%?(B-1
		dumy /= 10;			//$B<!$N7e$X(B
	}
	i = 0;					// $B%V%i%s%-%s%0=hM}(B
	buffer++;
	while((i<seisu)&&(*buffer == '0')){     // $B>e0L7e$,(B0$B$N4V(B
		*buffer = ' ';			// $B%V%i%s%/$KJQ49(B
		buffer++;                       // $B%]%$%s%?99?7(B
		i++;                            // $B%$%s%G%C%/%999?7(B
	}
}
/***************************************
*  Timer1,USART$B<u?.3d$j9~$_=hM}4X?t(B
****************************************/
void interrupt isr(void){
    unsigned char data;
    int i;

    if(PIR1bits.TMR1IF){                        // Timer1 50msec$B<~4|(B
        PIR1bits.TMR1IF = 0;
        TMR1H = 0x3C;
        TMR1L = 0xAF;
        Interval++;                             // 15sec$B<~4|MQ(B
    }
    if(PIR1bits.RCIF){                          // $B<u?.3d$j9~$_$+!)(B
        PIR1bits.RCIF = 0;                      // $B<u?.3d$j9~$_%U%i%0%/%j%"(B
        if((RCSTAbits.OERR)||(RCSTAbits.FERR)){ // $B%(%i!<H/@8$7$?>l9g(B
            data = RCREG;                       // $B%@%_!<FI$_=P$7(B
            RCSTA = 0;                          // USART$BL58z2=(B
            RCSTA = 0x90;                       // USART$B:FM-8z2=(B
        }
        else {                                  // $B@5>o<u?.$N>l9g(B
            if(Index < Max_Size){               // $B%P%C%U%!%*!<%P!<%U%m!<$G$J$$>l9g(B
                data = RCREG;                   // $B%G!<%?<h$j=P$7(B
                if(data == 'S')                 // $B3+;O%^!<%/$N>l9g(B
                    Index = 0;                  // $B%P%C%U%!%$%s%G%C%/%9%j%;%C%H(B
                RcvBuf[Index] = data;           // $B%G!<%?3JG<(B
                /* $B=*N;%^!<%/$N=hM}(B */
                if(RcvBuf[Index] == 'E'){       // $B=*N;%^!<%/(BE$B8!=P(B
                    i = 0;                      // $B%]%$%s%?%j%;%C%H(B
                    while(i <= Index){          // $B<u?.%P%$%H?t7+$jJV$7(B
                        Buffer[i] = RcvBuf[i];  // $B%3%T!<(B
                        i++;                    // $B%P%C%U%!%]%$%s%?99?7(B
                    }
                    RcvFlag = 1;                // $B<u?.40N;%U%i%0%;%C%H(B
                }
                Index++;                        // $B%P%C%U%!%]%$%s%?99?7(B
            }
            else{                               // $B%P%C%U%!%*!<%P!<$N>l9g(B
                data = RCREG;                   // $BFI$_Ht$P$7$FL5;k(B
                Index = 0;                      // $B%$%s%G%C%/%9%j%;%C%H(B
            }
        }
    }
}
/********************************
 * USART $BAw?.<B9T%5%V4X?t(B
 ********************************/
void Send(unsigned char txchar){
    while(!TXSTAbits.TRMT);             // $BAw?.%l%G%#!<BT$A(B
    TXREG = txchar;                     // $BAw?.<B9T(B
}
/********************************
 * Bluetooth$BJ8;zNsAw?.4X?t(B
 *******************************/
void SendStr(unsigned char * str){
    int i;

    for(i= 0; i<Max_Size; i++)          // 32$B%P%$%HAw?.(B
        Send(*str++);                   // $BAw?.<B9T(B
}
/********************************
 * Bluetooth$B%3%^%s%IAw?.4X?t(B
 * $BCY1dA^F~8eLa$k(B
 ********************************/
void SendCmd(const unsigned char *cmd){
    while(*cmd != 0)                    // $B=*C<$^$G7+$jJV$7Aw?.(B
        Send(*cmd++);                   // $BAw?.<B9T(B
    Delayms(1000);                      // $BJV?.%9%-%C%WMQCY1d(B
}
/************************************
 *  $B%b%8%e!<%k=i4|2=4X?t(B
 * $B!!!!%*%Z%"%s%W!"(BDAC$B!"(BFVR$B!"%3%s%Q%l!<%?(B
 ***********************************/
void Init(void){
    /** $B%*%Z%"%s%W$N=i4|@_Dj(B **/
    OPA1CONbits.OPA1SP = 0;             // Low Speed
    OPA1CONbits.OPA1CH = 0;             // OPA1IN+ pin
    OPA1CONbits.OPA1EN = 1;             // Enable
    OPA2CONbits.OPA2SP = 0;             // Low Speed
    OPA2CONbits.OPA2CH = 0;             // OPA2IN+ pin
    OPA2CONbits.OPA2EN = 1;             // Enable
    /** FVR$B=i4|@_Dj(B **/
    FVRCONbits.CDAFVR = 1;              // 1.024V for DAC
    FVRCONbits.ADFVR = 3;               // 4.096V for ADC
    FVRCONbits.FVREN = 1;               // Enable
    /** DAC$B=i4|@_Dj(B **/
    DACCON0bits.DACOE1 = 1;             // Out Enable
    DACCON0bits.DACPSS = 2;             // FVR select
    DACCON0bits.DACNSS = 0;             // VSS select
    DACCON0bits.DACEN = 1;              // Enable
    DACCON1 = 20;                       // Initial set
    /** A/D$B%3%s%P!<%?$N=i4|@_Dj(B **/
    ADCON0 = 0x00;                      // Select AN0 OFF
    ADCON1bits.ADFM = 1;                // Sign int
    ADCON1bits.ADCS = 2;                // Tad=Fosc/32
    ADCON1bits.ADNREF = 0;              // Vss
    ADCON1bits.ADPREF = 3;              // FVR = 4.096
    ADCON2bits.TRIGSEL = 3;             // Trigger Disable
    ADCON2bits.CHSN = 15;               // by ADNREF
    ADCON0bits.ADON = 1;                // ADC Enbale
}